/* ==========================================================================
 * AnonNet - Anonymous Network Project
 * --------------------------------------------------------------------------
 * Copyright (C) 2001  William Ahern
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * ==========================================================================
 */

#ifndef _LIST_H
#define _LIST_H 1

#include "common.h"
#include "thread.h"
#include "queue.h"


/*
 * List
 *
 */
struct list;
struct list_item;

typedef struct list {
	/* Inherit Object */
	object_t object;
	bool __of_objects;

	struct list_item *head;
	struct list_item *tail;

	unsigned int size;
} list_t;

typedef struct list_item {
	struct list_item *next;
	struct list_item *prev;
	bool is_object;
	void *value;
} list_item_t;


list_t *list_create(bool);
void list_free(void *);
void *list_pop(list_t *);
void *list_shift(list_t *);
void *list_push(list_t *,void *);
void *list_unshift(list_t *,void *);

/* end List */

#endif /* _LIST_H */
